//////////////////////////////////////////////////////////////////////////////////

// Module Name:Barrel_Shifter 
// Target Devices: EP4CE6E22C8N
// Tool versions: Quartus II 14.1
// Description: This example shows a simple 8-bit barrele shifter that rotates one bit to the right
// in the interval of 1/4 second. The state of the shift register is displayed on 8 LEDs.The .sof file can be directly downloaded to 
// EP4CE6 Mini Board.

//////////////////////////////////////////////////////////////////////////////////

module Barrel_Shifter( input clk_50M, input reset, output [7:0] led );

reg [23:0]  counter;
reg [7:0]   shift_reg = 8'b0000_0001;

always@( posedge clk_50M )
begin
	if( reset )
	begin
		counter <= 0;
	end
	else
		counter <= counter + 1'b1;
end

always @( posedge clk_50M )
begin
	if( reset )
		shift_reg <= 8'b0000_0001;
	else
	begin
	if( counter == 24'b1011_1110_1011_1100_0010_0000 )
		shift_reg <= { shift_reg[6:0],shift_reg[7] }; // shift left
	end
end

assign led[7:0] = shift_reg[7:0];

endmodule



